"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var error_message_service_1 = require('../services/error-message.service');
var validate_directive_1 = require('./validate.directive');
var ErrorsComponent = (function () {
    function ErrorsComponent(errorMessageService, validate, formGroupDirective, ngForm) {
        this.errorMessageService = errorMessageService;
        this.validate = validate;
        this.formGroupDirective = formGroupDirective;
        this.ngForm = ngForm;
        this.form = this.formGroupDirective || this.ngForm;
    }
    ErrorsComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.formGroup = this.form.form;
        this.formGroup.valueChanges.subscribe(function () { return _this.getErrors(); });
        this.validate.showErrors.subscribe(function () { return _this.getErrors(); });
    };
    ErrorsComponent.prototype.getErrors = function () {
        if (this.form.submitted) {
            this.errors = [];
            this.getErrorsFromControls(this.formGroup.controls);
        }
    };
    ErrorsComponent.prototype.getErrorsFromControls = function (controls) {
        for (var _i = 0, _a = Object.keys(controls); _i < _a.length; _i++) {
            var fieldName = _a[_i];
            var control = controls[fieldName];
            if (control instanceof forms_1.FormGroup) {
                this.getErrorsFromControls(control.controls);
            }
            if (control.errors) {
                this.addErrors(fieldName, controls[fieldName].errors);
            }
        }
    };
    ErrorsComponent.prototype.addErrors = function (fieldName, errors) {
        for (var _i = 0, _a = Object.keys(errors); _i < _a.length; _i++) {
            var error = _a[_i];
            this.errors.push({
                field: this.errorMessageService.getFieldName(fieldName),
                message: this.errorMessageService.getErrorMessage(error, errors[error])
            });
        }
    };
    ErrorsComponent = __decorate([
        core_1.Component({
            selector: 'errors',
            template: "<ul>\n                <li *ngFor=\"let error of errors\">\n                    <b>{{error.field}}</b>: {{error.message}}\n                </li>\n            </ul>"
        }),
        __param(1, core_1.Host()),
        __param(2, core_1.Optional()),
        __param(3, core_1.Optional()),
        __param(3, core_1.Host()), 
        __metadata('design:paramtypes', [error_message_service_1.ErrorMessageService, validate_directive_1.ValidateDirective, forms_1.FormGroupDirective, forms_1.NgForm])
    ], ErrorsComponent);
    return ErrorsComponent;
}());
exports.ErrorsComponent = ErrorsComponent;
//# sourceMappingURL=errors.component.js.map